Index: core/src/main/java/com/orientechnologies/orient/core/index/OIndexMVRBTreeAbstract.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- core/src/main/java/com/orientechnologies/orient/core/index/OIndexMVRBTreeAbstract.java	(revision 5536)
+++ core/src/main/java/com/orientechnologies/orient/core/index/OIndexMVRBTreeAbstract.java	(revision )
@@ -82,8 +82,10 @@
 
     type = iType;
     watchDog = new Listener() {
+      private final long memoryOptimizationThreshold = OGlobalConfiguration.MVRBTREE_MEMORY_OPTIMIZATION_THRESHOLD.getValueAsLong();
+
       public void memoryUsageLow(final long iFreeMemory, final long iFreeMemoryPercentage) {
-        map.setOptimization(iFreeMemoryPercentage < 10 ? 2 : 1);
+        map.setOptimization(iFreeMemoryPercentage < memoryOptimizationThreshold ? 2 : 1);
       }
     };
   }
Index: core/src/main/java/com/orientechnologies/orient/core/config/OGlobalConfiguration.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- core/src/main/java/com/orientechnologies/orient/core/config/OGlobalConfiguration.java	(revision 5536)
+++ core/src/main/java/com/orientechnologies/orient/core/config/OGlobalConfiguration.java	(revision )
@@ -135,6 +135,10 @@
       "Multiplicand factor to apply to entry-points list (parameter mvrbtree.entrypoints) to determine optimization is needed",
       Float.class, 1.0f),
 
+  MVRBTREE_MEMORY_OPTIMIZATION_THRESHOLD("mvrbtree.memoryOptimizationThreshold",
+      "Threshold for heap memory at which optimization of tree map memory usage starts. Optimize tree map when level of free memory less than X%",
+      Long.class, 20L),
+
   MVRBTREE_ENTRY_KEYS_IN_MEMORY("mvrbtree.entryKeysInMemory", "Keep unserialized keys in memory", Boolean.class, Boolean.FALSE),
 
   MVRBTREE_ENTRY_VALUES_IN_MEMORY("mvrbtree.entryValuesInMemory", "Keep unserialized values in memory", Boolean.class,
